Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members Related Pages

# ACE_POSIX_AIOCB_Asynch_Read_Dgram Class Reference

This class is a factory for starting off asynchronous reads on a UDP socket. More...

`#include <POSIX_Asynch_IO.h>`

Inheritance diagram for ACE_POSIX_AIOCB_Asynch_Read_Dgram

[legend]
Collaboration diagram for ACE_POSIX_AIOCB_Asynch_Read_Dgram:

[legend]
List of all members.

## Public Methods
| ACE_POSIX_AIOCB_Asynch_Read_Dgram (ACE_POSIX_AIOCB_Proactor *posix_aiocb_proactor)
| Constructor.
virtual | ~ACE_POSIX_AIOCB_Asynch_Read_Dgram (void)
virtual ssize_t | recv (ACE_Message_Block *message_block, size_t &number_of_bytes_recvd, int flags, int protocol_family, const void *act, int priority, int signal_number)
int | open (ACE_Handler &handler, ACE_HANDLE handle, const void *completion_key, ACE_Proactor *proactor)
int | cancel (void)
ACE_Proactor* | proactor (void) const
| Return the underlying proactor.
## Protected Methods
| ACE_POSIX_AIOCB_Asynch_Read_Dgram (void)
| Do-nothing constructor.

## Detailed Description

This class is a factory for starting off asynchronous reads on a UDP socket.

Once <open> is called, multiple asynchronous <read>s can be started using this class. An ACE_Asynch_Read_Dgram::Result will be passed back to the <handler> when the asynchronous reads completes through the callback.

## Constructor & Destructor Documentation

ACE_POSIX_AIOCB_Asynch_Read_Dgram::ACE_POSIX_AIOCB_Asynch_Read_Dgram ( | ACE_POSIX_AIOCB_Proactor * posix_aiocb_proactor )

| Constructor.

ACE_POSIX_AIOCB_Asynch_Read_Dgram::~ACE_POSIX_AIOCB_Asynch_Read_Dgram ( | void )`[virtual]`

ACE_POSIX_AIOCB_Asynch_Read_Dgram::ACE_POSIX_AIOCB_Asynch_Read_Dgram ( | void )`[protected]`

| Do-nothing constructor.

## Member Function Documentation

int ACE_POSIX_AIOCB_Asynch_Read_Dgram::cancel ( | void )

| This cancels all pending accepts operations that were issued by the calling thread. The function does not cancel asynchronous operations issued by other threads. Reimplemented from ACE_POSIX_Asynch_Operation.

int ACE_POSIX_AIOCB_Asynch_Read_Dgram::open ( | ACE_Handler & handler,
| ACE_HANDLE handle,
| const void * completion_key,
| ACE_Proactor * proactor )

| Initializes the factory with information which will be used with each asynchronous call. If (<handle> == ACE_INVALID_HANDLE), will be called on the <handler> to get the correct handle. Reimplemented from ACE_POSIX_Asynch_Operation.

ACE_Proactor * ACE_POSIX_AIOCB_Asynch_Read_Dgram::proactor ( | void ) const

| Return the underlying proactor. Reimplemented from ACE_POSIX_Asynch_Operation.

ssize_t ACE_POSIX_AIOCB_Asynch_Read_Dgram::recv ( | ACE_Message_Block * message_block,
| size_t & number_of_bytes_recvd,
| int flags,
| int protocol_family,
| const void * act,
| int priority,
| int signal_number )`[virtual]`

| This starts off an asynchronous read. Upto <message_block->total_size()> will be read and stored in the <message_block>. <message_block>'s <wr_ptr> will be updated to reflect the added bytes if the read operation is successful completed. Return code of 1 means immediate success and number_of_bytes_recvd will contain number of bytes read. The method will still be called. Return code of 0 means the IO will complete proactively. Return code of -1 means there was an error, use errno to get the error code. Priority of the operation is specified by <priority>. On POSIX4-Unix, this is supported. Works like <nice> in Unix. Negative values are not allowed. 0 means priority of the operation same as the process priority. 1 means priority of the operation is one less than process. <signal_number> argument is a no-op on non-POSIX4 systems.

The documentation for this class was generated from the following files:

- POSIX_Asynch_IO.h
- POSIX_Asynch_IO.cpp